import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { cls } from "../lib/utils";
import { faCheck, faEye, faEyeSlash, faFile } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { useState } from "react";
import Button from "./Button";
export function InputText({ name, placeholder = "", title, cols = "1" }) {
    return (_jsx(Wrapper, { title: title, cols: cols, children: _jsx("input", { name: name, placeholder: placeholder, className: "w-full outline-none text-lg py-1 px-5 rounded-sm" }) }));
}
export function InputRadio({ cols = 1, title, options = [], ...props }) {
    return (_jsx(Wrapper, { title: title, cols: cols, children: _jsx("div", { className: "flex gap-2 h-full", children: options.map((item) => (_jsxs("label", { className: "relative flex-1 h-full cursor-pointer select-none", children: [_jsx("input", { className: "hidden [&:checked~div]:w-full [&:checked~span>svg]:w-4 [&:checked~span>svg]:h-4 [&:checked~span]:text-[#2c74dc]", type: "radio", value: item.value, defaultChecked: item.checked ? true : false, ...props }), _jsxs("span", { className: "relative z-10 flex items-center justify-center gap-2 h-full", children: [item.text, _jsx(FontAwesomeIcon, { icon: faCheck, className: "text-[#2c74dc] w-0 h-0 transition-all duration-200" })] }), _jsx("div", { className: "absolute bottom-0 left-1/2 -translate-x-1/2 w-0 h-[2px] transition-[width] duration-200 bg-[#2c74dc]" })] }, item.value))) }) }));
}
export function InputPassword({ name, title, placeholder = "Ingresa tu contraseña", cols = 1, }) {
    const [showPass, setShowPass] = useState(false);
    return (_jsx(Wrapper, { title: title, cols: cols, withBackground: false, children: _jsxs("div", { className: "flex flex-row h-full inputpass gap-2", children: [_jsx("input", { name: name, type: showPass ? "password" : "text", placeholder: placeholder, className: "w-full h-full outline-none text-lg py-1 px-5 rounded-sm" }), _jsx(Button, { type: "button", theme: "info", classWrapper: "rounded-sm", scaleHover: false, onClick: () => setShowPass(!showPass), icon: showPass ? faEye : faEyeSlash })] }) }));
}
export function InputSelect({ title, name, placeholder = "Selecciona una opción", cols = "1", options = [], }) {
    return (_jsx(Wrapper, { title: title, cols: cols, children: _jsxs("select", { name: name, className: "w-full h-full outline-none pl-4", children: [_jsx("option", { value: "", children: placeholder }), options.map((item) => (_jsx("option", { value: item.value, children: item.text }, item.value)))] }) }));
}
export function InputTextarea({ title, name, placeholder = "Escribe algo..", cols = "1", classInput = "", }) {
    return (_jsx(Wrapper, { title: title, cols: cols, children: _jsx("textarea", { name: name, placeholder: placeholder, className: cls("w-full min-h-full outline-none p-2", classInput) }) }));
}
export function InputFile({ title, name, placeholder = "Seleccionar", accept = "", cols = "1", }) {
    return (_jsx(Wrapper, { title: title, cols: cols, children: _jsxs("label", { className: "relative flex  items-center w-full h-full gap-1 pl-2 cursor-pointer", children: [_jsx("input", { type: "file", className: "cursor-pointer", accept: accept, name: name }), _jsxs("div", { className: "absolute left-0 flex w-[160px] h-full bg-[#2c74dc] text-white text-sm items-center gap-1 px-2 rounded-sm", children: [_jsx(FontAwesomeIcon, { icon: faFile, className: "w-5 h-5" }), _jsx("span", { className: "flex items-center w-full h-full", children: placeholder })] })] }) }));
}
function Wrapper({ children, title, withBackground = true, cols = 1 }) {
    return (_jsxs("div", { className: cls("flex flex-col gap-1 w-full", {
            "lg:col-span-2": cols == 2,
        }), children: [_jsx("h3", { className: "font-semibold", children: title }), _jsx("div", { className: cls("min-h-10 border-black/20 rounded-sm overflow-hidden", {
                    "bg-white": withBackground,
                }), children: children })] }));
}
